



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>angular核心原理解析2：注入器的创建和使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">angular核心原理解析2：注入器的创建和使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-17 20:11:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>上一课没有讲到创建注入器的方法createInjector。</p>
<p>此方法，会创建两种不同的注入器：第一种叫做providerInjector，第二种叫做instanceInjector。providerInjector是用来创建provider的，instanceInjector是用来创建一个对象实例的。</p>
<p>我们可以在js代码中直接使用注入器：</p>
<p>var myModule = angular.module("myModule", []);</p>
<p>myModule.factory("person", function(){ &nbsp; &nbsp;//定义了一个服务person</p>
<p>　　return {</p>
<p>　　　　name:"chaojidan"</p>
<p>　　}</p>
<p>});</p>
<p>myModule.controller("myController", ["$scope", "$injector", &nbsp; &nbsp; //myController依赖于服务person，但是它不声明依赖于person，而是通过注入器$injector来获得服务person的实例对象。</p>
<p>　　function($scope, $injector){</p>
<p>　　　　$injector.invoke(function(person){ &nbsp; //通过注入器$injector的invoke方法，把服务person的实例注入到函数function中。</p>
<p>　　　　　　console.log(person.name);</p>
<p>　　　　});</p>
<p>　　}</p>
<p>])</p>
<p>注入器$injector的annotate方法的作用：它主要分析函数的参数签名。比如：</p>
<p>$injector.annotate(function(arg1,arg2){})会得到[arg1, arg2]。</p>
<p>在前面的操作中，我们经常使用函数参数声明的方式来注入一个服务（实例对象），其实angular就是通过annotate方法得到参数的名字，然后通过注入器实例化这些对象，最后注入到函数中。</p>
<div>
<pre class="prettyprint linenums">function annotate(fn) {<br />
        var $inject,<br />
            fnText,<br />
            argDecl,<br />
            last;

        if (typeof fn == 'function') {<br />
            if (!($inject = fn.$inject)) {<br />
                $inject = [];<br />
                if (fn.length) {<br />
                    fnText = fn.toString().replace(STRIP_COMMENTS, '');<br />
                    argDecl = fnText.match(FN_ARGS);<br />
                    forEach(argDecl[1].split(FN_ARG_SPLIT), function(arg){<br />
                        arg.replace(FN_ARG, function(all, underscore, name){<br />
                            $inject.push(name);<br />
                        });<br />
                    });<br />
                }<br />
                fn.$inject = $inject;<br />
            }<br />
        } else if (isArray(fn)) {<br />
            last = fn.length - 1;<br />
            assertArgFn(fn[last], 'fn');<br />
            $inject = fn.slice(0, last);<br />
        } else {<br />
            assertArgFn(fn, 'fn', true);<br />
        }<br />
        return $inject;<br />
    }</pre>
</div>
<p>它是怎么获得函数的参数声明的呢？其实它是通过函数的toString方法得到整个函数的描述，然后通过正则表达式得到函数的参数。</p>
<p>在angular中，所有的provider都可以用来进行注入。我们创建provider有以下几种方式：</p>
<p>provider/factory/service/constant/value。</p>
<p>我们创建好provider之后，注入到哪里去呢？我们有以下几种方式来注入provider：</p>
<p>controller/directive/filter/service/factory等。</p>
<p>举个例子：</p>
<p>var myModule = angular.module("myModule", []);</p>
<p>myModule.provider("helloAngular", function(){ &nbsp; &nbsp; &nbsp;//通过provider方法创建一个服务提供者helloAngular</p>
<p>　　return {</p>
<p>　　　　$get : function(){ &nbsp; &nbsp;//provider方法来定义服务提供者的话，必须定义$get方法。</p>
<p>　　　　　　var name = "chaojidan";</p>
<p>　　　　　　function getName(){</p>
<p>　　　　　　　　return name;</p>
<p>　　　　　　}</p>
<p>　　　　　　return {</p>
<p>　　　　　　　　getName: getName</p>
<p>　　　　　　}</p>
<p>　　　　}</p>
<p>　　}</p>
<p>});</p>
<p>myModule.controller("myController", ["$scope", "helloAngular" , &nbsp; &nbsp; //通过controller方法注入helloAngular服务，也就是注入一个helloAngular服务的实例对象</p>
<p>　　function($scope, helloAngular){</p>
<p>　　　　$scope.name = helloAngular.getName(); &nbsp; &nbsp; //使用helloAngular服务的实例对象</p>
<p>　　}</p>
<p>])</p>
<p>第二个例子：</p>
<p>var myModule = angular.module("myModule", []);</p>
<p>myModule.factory("helloAngular", function(){ &nbsp; &nbsp; &nbsp;//通过factory方法创建一个服务提供者helloAngular</p>
<p>　　var name = "chaojidan";</p>
<p>　　function getName(){</p>
<p>　　　　return name;</p>
<p>　　}</p>
<p>　　return {</p>
<p>　　　　getName:getName</p>
<p>　　}</p>
<p>});</p>
<p>myModule.controller("myController", ["$scope", "helloAngular" , &nbsp; &nbsp; //通过controller方法注入helloAngular服务，也就是注入一个helloAngular服务的实例对象</p>
<p>　　function($scope, helloAngular){</p>
<p>　　　　$scope.name = helloAngular.getName(); &nbsp; &nbsp; //使用helloAngular服务的实例对象</p>
<p>　　}</p>
<p>])</p>
<p>第三个例子：</p>
<p>var myModule = angular.module("myModule", []);</p>
<p>myModule.service("helloAngular", function(){ &nbsp; &nbsp; &nbsp;//通过service方法创建一个服务提供者helloAngular</p>
<p>　　this.name = "chaojidan";</p>
<p>　　this.getName = function(){</p>
<p>　　　　return this.name;</p>
<p>　　}</p>
<p>});</p>
<p>myModule.controller("myController", ["$scope", "helloAngular" , &nbsp; &nbsp; //通过controller方法注入helloAngular服务，也就是注入一个helloAngular服务的实例对象</p>
<p>　　function($scope, helloAngular){</p>
<p>　　　　$scope.name = helloAngular.getName(); &nbsp; &nbsp; //使用helloAngular服务的实例对象</p>
<p>　　}</p>
<p>])</p>
<p>其实从angular源码可以知道，创建provider的这几种方式：provider/factory/service/constant/value，其中，</p>
<p>provider方法是基础，其他都是调用provider方法实现的，只是参数不同。从左到右，灵活性越差。</p>
<div>
<pre class="prettyprint linenums">function provider(name, provider_) {<br />
           assertNotHasOwnProperty(name, 'service');<br />
           if (isFunction(provider_) || isArray(provider_)) {<br />
                provider_ = providerInjector.instantiate(provider_);<br />
           }<br />
           if (!provider_.$get) {<br />
               throw $injectorMinErr('pget', "Provider '{0}' must define $get factory method.", name);<br />
           }<br />
           return providerCache[name + providerSuffix] = provider_;<br />
}

function factory(name, factoryFn) { 

　　　　return provider(name, { $get: factoryFn }); <br />}<br />
function service(name, constructor) {<br />
            return factory(name, ['$injector', function($injector) {<br />
                return $injector.instantiate(constructor);<br />
            }]);<br />
}<br />
function value(name, val) { 

　　return factory(name, valueFn(val)); <br />}<br />
function constant(name, value) {<br />
            assertNotHasOwnProperty(name, 'constant');<br />
            providerCache[name] = value;<br />
            instanceCache[name] = value;<br />
}</pre>
</div>
<p>createInjector方法里面，其实是通过createInternalInjector方法来创建注入器的。</p>
<div>
<pre class="prettyprint linenums">function createInternalInjector(cache, factory) {<br />
        function getService(serviceName) {     //注入器可以用来获取一个服务的实例<br />
                if (cache.hasOwnProperty(serviceName)) {<br />
                    if (cache[serviceName] === INSTANTIATING) {<br />
                        throw $injectorMinErr('cdep', 'Circular dependency found: {0}', path.join(' &lt;- '));<br />
                    }<br />
                    return cache[serviceName];<br />
                } else {<br />
                    try {<br />
                        path.unshift(serviceName);<br />
                        cache[serviceName] = INSTANTIATING;<br />
                        return cache[serviceName] = factory(serviceName);<br />
                    } catch (err) {<br />
                        if (cache[serviceName] === INSTANTIATING) {<br />
                            delete cache[serviceName];<br />
                        }<br />
                        throw err;<br />
                    } finally {<br />
                        path.shift();<br />
                    }<br />
                }<br />
        }

        function invoke(fn, self, locals){    //可以用来调用一个方法<br />
                var args = [],<br />
                    $inject = annotate(fn),<br />
                    length, i,<br />
                    key;

                for(i = 0, length = $inject.length; i &lt; length; i++) {<br />
                    key = $inject[i];<br />
                    if (typeof key !== 'string') {<br />
                        throw $injectorMinErr('itkn',<br />
                            'Incorrect injection token! Expected service name as string, got {0}', key);<br />
                    }<br />
                    args.push(<br />
                        locals &amp;&amp; locals.hasOwnProperty(key)<br />
                            ? locals[key]<br />
                            : getService(key)<br />
                    );<br />
                }<br />
                if (!fn.$inject) {<br />
                    // this means that we must be an array.<br />
                    fn = fn[length];<br />
                }

                // http://jsperf.com/angularjs-invoke-apply-vs-switch<br />
                // #5388<br />
                return fn.apply(self, args);<br />
      }

     function instantiate(Type, locals) {   //可以用来实例化一个对象<br />
                var Constructor = function() {},<br />
                    instance, returnedValue;

                // Check if Type is annotated and use just the given function at n-1 as parameter<br />
                // e.g. someModule.factory('greeter', ['$window', function(renamed$window) {}]);<br />
                Constructor.prototype = (isArray(Type) ? Type[Type.length - 1] : Type).prototype;<br />
                instance = new Constructor();<br />
                returnedValue = invoke(Type, instance, locals);

                return isObject(returnedValue) || isFunction(returnedValue) ? returnedValue : instance;<br />
    }

    return {    //返回的对象，其实就是注入器<br />
                invoke: invoke,<br />
                instantiate: instantiate,<br />
                get: getService,<br />
                annotate: annotate,    //可以用来分析一个函数的签名<br />
                has: function(name) {<br />
                    return providerCache.hasOwnProperty(name + providerSuffix) || cache.hasOwnProperty(name);<br />
                }<br />
    };<br />
}</pre>
</div>
<p>注入器总共有invoke，instantiate，get，annotate，has五个方法，其中，annotate用来分析一个函数的签名，也就是函数的参数，invoke用来调用一个函数，get用来获得一个服务的实例对象，instantiate用来实例化一个对象。</p>
<p>angularJS在初始化启动时，注册了一些内置的provider。在publishExternalAPI方法中：</p>
<div>
<pre class="prettyprint linenums">$provide.provider({<br />
                    $anchorScroll: $AnchorScrollProvider,<br />
                    $animate: $AnimateProvider,<br />
                    $browser: $BrowserProvider,<br />
                    $cacheFactory: $CacheFactoryProvider,<br />
                    $controller: $ControllerProvider,<br />
                    $document: $DocumentProvider,<br />
                    $exceptionHandler: $ExceptionHandlerProvider,<br />
                    $filter: $FilterProvider,<br />
                    $interpolate: $InterpolateProvider,<br />
                    $interval: $IntervalProvider,<br />
                    $http: $HttpProvider,<br />
                    $httpBackend: $HttpBackendProvider,<br />
                    $location: $LocationProvider,<br />
                    $log: $LogProvider,<br />
                    $parse: $ParseProvider,<br />
                    $rootScope: $RootScopeProvider,<br />
                    $q: $QProvider,<br />
                    $sce: $SceProvider,<br />
                    $sceDelegate: $SceDelegateProvider,<br />
                    $sniffer: $SnifferProvider,<br />
                    $templateCache: $TemplateCacheProvider,<br />
                    $timeout: $TimeoutProvider,<br />
                    $window: $WindowProvider<br />
});</pre>
</div>
<p>我们以$controller: $ControllerProvider,为例子，来看下内置的provider是如何定义的？</p>
<div>
<pre class="prettyprint linenums">    function $ControllerProvider() {<br />
        var controllers = {},<br />
            CNTRL_REG = /^(\S+)(\s+as\s+(\w+))?$/;<br />
        this.register = function(name, constructor) {<br />
            assertNotHasOwnProperty(name, 'controller');<br />
            if (isObject(name)) {<br />
                extend(controllers, name);<br />
            } else {<br />
                controllers[name] = constructor;<br />
            }<br />
        };<br />
        this.$get = ['$injector', '$window', function($injector, $window) {    //provider必须有$get方法<br />
            return function(expression, locals) {<br />
                var instance, match, constructor, identifier;<br />
                if(isString(expression)) {<br />
                    match = expression.match(CNTRL_REG),<br />
                        constructor = match[1],<br />
                        identifier = match[3];<br />
                    expression = controllers.hasOwnProperty(constructor)<br />
                        ? controllers[constructor]<br />
                        : getter(locals.$scope, constructor, true) || getter($window, constructor, true);<br />
                    assertArgFn(expression, constructor, true);<br />
                }<br />
                instance = $injector.instantiate(expression, locals);    //当你想去拿控制器，也就是controller实例时，实际上是注入器帮你实例化的。<br />
                if (identifier) {<br />
                    if (!(locals &amp;&amp; typeof locals.$scope == 'object')) {<br />
                        throw minErr('$controller')('noscp',<br />
                            "Cannot export controller '{0}' as '{1}'! No $scope object provided via `locals`.",<br />
                            constructor || expression.name, identifier);<br />
                    }<br />
                    locals.$scope[identifier] = instance;<br />
                }<br />
                return instance;<br />
            };<br />
        }];<br />
    }</pre>
</div>
<p>当你的应用中，需要控制器实例对象时，也就是需要controller这个服务时，实际上是注入器在ControllerProvider（控制器服务提供者）中实例化一个控制器实例对象，然后给应用的（注入进去）。</p>
<p>加油！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8ezre81.html">MongoDB安装使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdeyjj9.html">论php数组合并</a>
		</li>
						<li><a href="https://www.batexi.com/a/495gvo6q.html">我的编程开始（C）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ko2y7q.html">MySQL优化概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p3144q.html">C语言scanf函数详细解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e3rwzq.html">html5 datepicke</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kry06q.html">解决html表格中内容超出不强制换行和超出宽度自动隐藏并显示省略号</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvp2mzq.html">OID View</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmvnme9.html">Tableau学习笔记之五</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1wd2j9.html">day02  Java基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmor379.html">ecshop中404错误页面设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j20v38.html">oracle job执行失败</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j6weo8.html">UWP 共享文件&mdash;&mdash;接收者</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rknw28.html">CentOS7&plus;CDH5&period;14&period;0安装CDH错误排查：HBase服务出现 该运行状况测试不良，因为 Service Monitor 未找到活动 Master</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4j5pj9.html">Math&period;round&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j332nq.html">Python：每日一题003</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wr1jnq.html">cProfile&mdash;&mdash;Python性能分析工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j0lpeq.html">oracle-闪回技术1</a>
		</li>
						<li><a href="https://www.batexi.com/a/960vdk49.html">Java JDK版本切换--绝逼好使</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwzxrz8.html">2018&period;11&period;02 洛谷P2831 愤怒的小鸟（状压dp）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jm4rog9.html">LevelDB Cache机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql13dje9.html">FP变更物料编码（增加尾缀）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7eyvrx9.html">【HDU5992】Finding Hotels 【KD树】</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlmyjk9.html">jmeter 使用cookie管理器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnrlmeq.html">SpringBoot31 重识Spring01-环境搭建、Actuator监控、属性配置、多环境配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v6xozq.html">使用twised实现一个EchoServer</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2mmej8.html">Qt Customize QVariant</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emllge9.html">select&lowbar;shape&lowbar;proto算子的几种特征模式含义解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppoork9.html">vue elementui form表单验证</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2mm7d8.html">二维数组中的查找&lpar;java&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
